''This code example is from Propeller Education Kit Labs: Fundamentals, v1.1.
''A .pdf copy of the book is available from www.parallax.com, and also through
''the Propeller Tool software's Help menu (v1.2.6 or newer).
''
'' File: EnterAndDisplayValues.spin
'' Messages to/from Propeller chip with Parallax Serial Terminal. Prompts you to enter a '' value, and displays the value in decimal, binary, and hexadecimal formats.

CON
   
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
   


OBJ
   
  Debug: "FullDuplexSerialPlus"
  gps: "GPS_IO_mini"
  fmath : "FloatMath"
  Fstring: "FloatString"
  
   
PUB TwoWayCom | value,latsec,decconv,debugtest,latmin,latcor,seccon,add1,latitude,latdec
  
  ''Test Parallax Serial Terminal number entry and display.
  
  Debug.start(31, 30, 0, 4800)
  waitcnt(clkfreq*2 + cnt)
  Debug.tx(16)
  gps.start
  'FFmath.start
  
  seccon :=10000
  decconv := 60
  add1:= 1
  
  repeat
  
     latsec := latsec2dec(gps.latitude)
     latmin := latmin2dec(gps.latitude)
     add1 := latsec+(latmin * seccon)
     debug.dec(add1)
     Debug.str(String(13))
      
     'debug.dec(latsec)
     'Debug.str(String(13))
     'debug.dec(latmin)
     'Debug.str(String(13)) 
     latsec := fmath.fdiv(add1,seccon)
     
     
     Debug.str(String(13))
     debug.str(fstring.floattostring(latsec))
     Debug.str(String(13))
     latdec:= fmath.ftrunc(latsec)
     debug.dec(latdec)
     Debug.str(String(13)) 
     'latitude := ffmath.fdiv(latsec,decconv)
     latdec := fmath.fdiv(latdec,decconv)
     debug.str(fstring.floattostring(latdec))
     'latdec := fmath.fmul(latdec,100)
     'debug.dec(latdec)
     'Debug.str(String(13)) 
     'debug.dec(latmin)
     'Debug.str(String(13))
     
     'latitude := fmath.fadd(latitude,latmin)
     'debug.str(fstring.FloatToString(latitude))
     'Debug.str(String(13)) 
     'Debug.Str(String("GPS OUT TEST "))
     'Debug.str(string("Latitude "))
     'Debug.str(String(13))
     
     Debug.str(gps.latitude)
     debug.str(string(13))
     'debug.str(gps.longitude)
     'debug.str(string(13)) 
     'debug.str(gps.longitude)
     'debug.str(string(13))
     
     waitcnt(clkfreq +cnt)
     
    repeat 2
        Debug.Str(String(13))

PUB latsec2dec(str)|index   
    result:=0
     repeat index from 5 to (strsize(str)-1)   
      if byte[str][index] == "."
        quit   
      result*=10
      result+=byte[str][index]-"0"

PUB latmin2dec(str)|index   
    result:=0
     repeat index from 2 to (strsize(str)-1)   
      if byte[str][index] == "."
        quit   
      result*=10
      result+=byte[str][index]-"0"


        
